From 5767699a22a6cb2468e09e34eedad235a4fac3a8 Mon Sep 17 00:00:00 2001
From: Gabriele Musco <gabmus@disroot.org>
Date: Sun, 26 Nov 2023 15:38:48 +0100
Subject: [PATCH 07/54] feat: adwaita styling (as much as possible with
 listview) for vulkan features/extensions window

---
 .../vulkan_info/feature_window/mod.rs         |  6 ++--
 .../vulkan_info/feature_window/row.rs         | 10 ++++++
 lact-gui/ui/vulkan_feature_row.blp            | 11 +++---
 lact-gui/ui/vulkan_features_window.blp        | 36 ++++++++++++-------
 4 files changed, 43 insertions(+), 20 deletions(-)

diff --git a/lact-gui/src/app/root_stack/info_page/vulkan_info/feature_window/mod.rs b/lact-gui/src/app/root_stack/info_page/vulkan_info/feature_window/mod.rs
index 3b42e7fb..349cf70a 100644
--- a/lact-gui/src/app/root_stack/info_page/vulkan_info/feature_window/mod.rs
+++ b/lact-gui/src/app/root_stack/info_page/vulkan_info/feature_window/mod.rs
@@ -6,7 +6,7 @@ use gtk::{gio, glib};
 
 glib::wrapper! {
     pub struct VulkanFeaturesWindow(ObjectSubclass<imp::VulkanFeaturesWindow>)
-        @extends gtk::Box, gtk::Widget, gtk::Window,
+        @extends gtk::Box, gtk::Widget, gtk::Window, libadwaita::Window,
         @implements gtk::Orientable, gtk::Accessible, gtk::Buildable;
 }
 
@@ -33,6 +33,7 @@ mod imp {
         CompositeTemplate, Expression, FilterListModel, PropertyExpression, SearchEntry,
         SignalListItemFactory, StringFilter, TemplateChild,
     };
+    use libadwaita::subclass::window::AdwWindowImpl;
     use std::cell::RefCell;
 
     #[derive(CompositeTemplate, Properties, Default)]
@@ -57,7 +58,7 @@ mod imp {
     impl ObjectSubclass for VulkanFeaturesWindow {
         const NAME: &'static str = "VulkanFeaturesWindow";
         type Type = super::VulkanFeaturesWindow;
-        type ParentType = gtk::Window;
+        type ParentType = libadwaita::Window;
 
         fn class_init(class: &mut Self::Class) {
             class.bind_template();
@@ -116,5 +117,6 @@ mod imp {
 
     impl WidgetImpl for VulkanFeaturesWindow {}
     impl WindowImpl for VulkanFeaturesWindow {}
+    impl AdwWindowImpl for VulkanFeaturesWindow {}
     impl ApplicationWindowImpl for VulkanFeaturesWindow {}
 }
diff --git a/lact-gui/src/app/root_stack/info_page/vulkan_info/feature_window/row.rs b/lact-gui/src/app/root_stack/info_page/vulkan_info/feature_window/row.rs
index 8eeca90a..23c9ecc6 100644
--- a/lact-gui/src/app/root_stack/info_page/vulkan_info/feature_window/row.rs
+++ b/lact-gui/src/app/root_stack/info_page/vulkan_info/feature_window/row.rs
@@ -77,6 +77,16 @@ mod imp {
                 })
                 .sync_create()
                 .build();
+            obj.bind_property("feature", &self.available_image.get(), "tooltip-text")
+                .transform_to(|_, feature: VulkanFeature| {
+                    if feature.supported() {
+                        Some("Supported")
+                    } else {
+                        Some("Unsupported")
+                    }
+                })
+                .sync_create()
+                .build();
         }
     }
 
diff --git a/lact-gui/ui/vulkan_feature_row.blp b/lact-gui/ui/vulkan_feature_row.blp
index a87daccc..b368da8b 100644
--- a/lact-gui/ui/vulkan_feature_row.blp
+++ b/lact-gui/ui/vulkan_feature_row.blp
@@ -4,13 +4,14 @@ template $VulkanFeatureRow: Box {
   focus-on-click: false;
   hexpand: true;
   hexpand-set: true;
-  margin-bottom: 10;
-  margin-end: 20;
-  margin-start: 20;
-  margin-top: 10;
+  margin-bottom: 12;
+  margin-end: 24;
+  margin-start: 24;
+  margin-top: 12;
 
   Label name_label {
-    halign: start;
+    xalign: 0.0;
+    ellipsize: end;
     hexpand: true;
     label: 'feature name';
     selectable: true;
diff --git a/lact-gui/ui/vulkan_features_window.blp b/lact-gui/ui/vulkan_features_window.blp
index 2b84a5b5..0ea3a315 100644
--- a/lact-gui/ui/vulkan_features_window.blp
+++ b/lact-gui/ui/vulkan_features_window.blp
@@ -1,23 +1,33 @@
 using Gtk 4.0;
+using Adw 1;
 
-template $VulkanFeaturesWindow: Window {
+template $VulkanFeaturesWindow: Adw.Window {
   default-height: 700;
   default-width: 500;
 
-  Box {
-    orientation: vertical;
-
-    SearchEntry search_entry {}
-
-    ScrolledWindow {
-      vexpand: true;
+  Adw.ToolbarView {
+    [top] Adw.HeaderBar {}
+    [top] SearchEntry search_entry {
+        margin-top: 6;
+        margin-bottom: 12;
+        margin-start: 12;
+        margin-end: 6;
+    }
 
-      ListView {
-        factory: features_factory;
-        model: selection_model;
-        show-separators: true;
+    content: Box {
+      orientation: vertical;
+  
+      ScrolledWindow {
+        vexpand: true;
+        hscrollbar-policy: never;
+  
+        ListView {
+          factory: features_factory;
+          model: selection_model;
+          show-separators: true;
+        }
       }
-    }
+    };
   }
 }
 

